#
# spec file for package star (Version 1.5a70)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           star
BuildRequires:  e2fsprogs-devel libacl-devel
License:        Other License(s), see package
Group:          Productivity/Archiving/Backup
AutoReqProv:    on
Provides:       rmt
Version:        1.5a70
Release:        12.10.41
Source:         ftp://ftp.berlios.de/pub/star/alpha/star-%{version}.tar.bz2
Source1:        README-FIRST
Source2:        tests.tar.bz2
Patch0:         star-configuration.diff
Patch2:         star-no_fsync.diff
Patch5:         rmt-move.diff
Patch6:         star-CVE-2007-4134.patch
Patch7:         star-lock.diff
Url:            http://www.fokus.gmd.de/research/cc/glone/employees/joerg.schilling/private/star.html
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Summary:        POSIX.1-2001-Compliant Tar Implementation

%description
Star is a tar like archiver. TAR stands for Tape ARchiver. Star is the
fastest known implementation of a tar archiver.

Features:

- FIFO to keep the tape streaming.

- remote tape support.

- accurate sparse files (if the OS supports it).

- pattern matcher to archive and extract a subset of files.

- user tailorable interface for comparing tar archives against file
   trees.

- path names up to 1024 Bytes may be archived.

- stores and restores all 3 file times (even creation time). With
POSIX.1-2001 the times are in nanosecond granularity.



Authors:
--------
    Joerg Schilling <schilling@fokus.gmd.de>

%prep
#%setup -b 2 -n tests
#%setup -b 0 -n star-1.5
%setup -q -T -b 2 -n tests -b 0 -n star-1.5
%patch0 -p1
%patch2 -p1
%patch5 -p1
%patch6
%patch7

%build
# Autoconf does not handle inline comments correctly: Split comments and
# variables into separate lines.
mv conf/xconfig.h.in conf/xconfig.h.in.orig
sed -e 's|\(#.*\)\(/\*.*\*/\)|\2\n\1|g' \
	conf/xconfig.h.in.orig >conf/xconfig.h.in
#ln -sf i586-linux-gcc.rul RULES/i586-linux-cc.rul
#ln -s i586-linux-cc.rul RULES/x86_64-linux-cc.rul
ln -s i586-linux-cc.rul RULES/s390x-linux-cc.rul
ln -s i586-linux-cc.rul RULES/ppc64-linux-cc.rul
#ln -s i586-linux-gcc.rul RULES/x86_64-linux-gcc.rul
ln -s i586-linux-gcc.rul RULES/s390x-linux-gcc.rul
ln -s i586-linux-gcc.rul RULES/ppc64-linux-gcc.rul
ln -s armv4l-linux-gcc.rul RULES/armv5tel-linux-gcc.rul
%{?suse_update_config:%{suse_update_config -f conf}}
cd conf
autoconf
%define star_cflags $RPM_OPT_FLAGS -g -W -Wall -Wpointer-arith -Wformat-security
cp %{SOURCE1} .
make all MAKEPROG=gmake MANDIR=share/man COPTX="%{star_cflags}" CPPOPTX="-D_GNU_SOURCE -DNO_FSYNC"

%install
make install MAKEPROG=gmake INS_BASE=$RPM_BUILD_ROOT/usr MANDIR=share/man
mkdir -p $RPM_BUILD_ROOT/etc/default
mkdir $RPM_BUILD_ROOT/sbin
install -m 644 rmt/rmt.dfl $RPM_BUILD_ROOT/etc/default/rmt
mv $RPM_BUILD_ROOT/usr/etc/default/{rmt,star} $RPM_BUILD_ROOT/etc/default
mv $RPM_BUILD_ROOT/usr/bin/star_fat $RPM_BUILD_ROOT/usr/bin/star
rm -f $RPM_BUILD_ROOT/usr/bin/ustar
rm -f $RPM_BUILD_ROOT/usr/bin/tar
ln -sf ./star $RPM_BUILD_ROOT/usr/bin/ustar
rm -rf $RPM_BUILD_ROOT/%{_prefix}/{lib,include,bin/mt} \
       $RPM_BUILD_ROOT%{_mandir}/man[35] \
       $RPM_BUILD_ROOT%{_mandir}/man1/{gnutar,scpio,smt,spax,suntar}.1 \
       $RPM_BUILD_ROOT/usr/bin/{spax,gnutar,scpio,suntar,star_sym}
# Run test suite?
(
   [ -r /proc/config.gz ] \
   && eval "$(zcat /proc/config.gz \
	| sed -e 's/^# \(.*\) is not set/\1=n/')"
    if [ "$CONFIG_EXT2_FS" == y -a \
	 "$CONFIG_EXT2_FS_POSIX_ACL"  == y -a \
	 "$CONFIG_EXT2_FS_XATTR_USER" == y ] ; then
	cd %_builddir/tests
	export PATH=$RPM_BUILD_ROOT/usr/bin:$PATH
	make
    else
	echo "Test suite skipped: requires a kernel with the " \
	     "CONFIG_EXT2_FS_POSIX_ACL and CONFIG_EXT2_FS_XATTR_USER features."
    fi
)
mv $RPM_BUILD_ROOT/usr/sbin/rmt $RPM_BUILD_ROOT/sbin
ln -sf ../sbin/rmt $RPM_BUILD_ROOT/etc/rmt

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AN* BUILD COMPILE INSTALL PORTING README Changelog COPYING README.* STARvsGNUTAR TODO
%config(noreplace) %attr(644, root, root) /etc/default/rmt
%config(noreplace) %attr(644, root, root) /etc/default/star
/usr/bin/smt
/usr/bin/star
/usr/bin/ustar
/usr/bin/tartest
/sbin/rmt
/etc/rmt
/usr/share/man/man1/match.1.gz
/usr/share/man/man1/rmt.1.gz
/usr/share/man/man1/star.1.gz
/usr/share/man/man1/tartest.1.gz

%changelog
* Tue Mar 10 2009 werner@suse.de
- Set read lock before using the semaphore wait on a pipe fd
  to avoid deadlock (bnc#414251)
* Tue Aug 28 2007 mkoenig@suse.de
- fix directory traversal CVE-2007-4134 [#302489]
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Dec 20 2005 mmj@suse.de
- update to 1.5a70
  o null.diff is upstream
* Fri Dec  9 2005 ro@suse.de
- disable selinux
* Tue Nov 22 2005 mmj@suse.de
- ustar should link to star [#134107]
* Tue Nov 15 2005 uli@suse.de
- link armv4l build rules to armv5tel (aka QEMU)
* Mon Jul 25 2005 nadvornik@suse.cz
- install symlink /etc/rmt -> /sbin/rmt
- provide rmt
* Thu Jul 21 2005 mmj@suse.de
- Disable fsync again [#97500]
- Enable null.diff
* Wed Jul 20 2005 mmj@suse.de
- Move rmt to /sbin [#97266]
* Tue Jun 28 2005 agruen@suse.de
- null.diff: Add -null option to star (patch from Bjrn Jacke).
* Fri Feb 18 2005 agruen@suse.de
- The new version also needs e2fsprogs-devel for some defines.
* Wed Feb 16 2005 agruen@suse.de
- star-acl-fix.diff: Drop this patch: it contains a bug (#50874)
  and nothing else that would be useful.
* Wed Feb 16 2005 agruen@suse.de
- Update to version 1.5a58-pre2.
* Wed Feb 16 2005 agruen@suse.de
- Add support for the ext3 'j' flag (per-file data journaling).
* Wed Aug 11 2004 mmj@suse.de
- Update to star-1.5a44
* Fri Jul  9 2004 mmj@suse.de
- Update to star-1.5a41 and move stuff from %%prep to %%build
* Mon Mar 15 2004 kukuk@suse.de
- Add SELinux support
* Fri Mar  5 2004 mmj@suse.de
- Fix testsuite
* Thu Mar  4 2004 mmj@suse.de
- Update to 1.5a38
* Sat Jan 10 2004 adrian@suse.de
- fix user build
* Mon Oct 13 2003 agruen@suse.de
- Upgrade to version 1.5a30.
* Mon Sep 15 2003 agruen@suse.de
- Upgrade to version 1.5a25.
- Another fix in star-acl-fix.diff.
- Rename star-alpha (ver. 1.5a25) to star, and drop star 1.4.3.
* Wed Sep 10 2003 agruen@suse.de
- Upgrade to version 1.5a24.
- Fix restoring of archives that contain broken acls.
* Thu Aug 21 2003 agruen@suse.de
- Fix bug in xattr patch that causes star to crash.
* Sun Jul 27 2003 agruen@suse.de
- Update to version 1.5a17.
- Don't do fsync for extracted files.
- Remove files that won't be packaged.
- Include tartest binary and manpage.
- Add test suite for acls and extended atributes.
* Tue Mar  4 2003 agruen@suse.de
- Split star-1.5 package from from star. Upgrade to latest alpha
  version.
* Tue Feb 25 2003 agruen@suse.de
- Fix several shortcomings and some bugs in the EA handling patch.
  (EA support in star on 8.2 beta 2 is broken -- which doesn't
  matter so much, since it's a new feature, anyway.)
* Mon Feb 24 2003 agruen@suse.de
- Add Extended Attributes handling patch. (Still needs to be
  discussed much forther with Jrg Schilling, so it is quite
  likely to change again soon.)
* Wed Jan 22 2003 agruen@suse.de
- Update to 1.4.2, which includes the fix from Oct 29.
- names-with-spaces.diff fixes a bug with spaces in user/group
  names of ACL entries.
- Update the Source tag in the spec file to the new FTP server (was:
  ftp://ftp.fokus.gmd.de/pub/unix/star/%%{name}-%%{version}.tar.bz2)
* Fri Dec 13 2002 ro@suse.de
- updated neededforbuild
* Tue Oct 29 2002 pthomas@suse.de
- Apply patch from agruen@suse.de to fix archive corruption.
* Fri Aug 16 2002 pthomas@suse.de
- Fix typo in README.SuSE
- Add acl,acl-devel, and attr to neededforbuild to make
  star support ACLs
* Tue Jun 25 2002 pthomas@suse.de
- Update to bugfix release 1.4.1
* Mon Jun  3 2002 pthomas@suse.de
- Add rules for ppc64-linux as symlinks to i586-linux.
* Wed May 29 2002 pthomas@suse.de
- Install /etc/default/rmt as %%config(noreplace)
- Add README.SuSE explaining configuration and setup for
  using rmt.
- Fix rmt manpage.
- Only install smt, as cpio provides mt.
- Don't install makefiles.5 and makerules.5
- Define _GNU_SOURCE unconditionally and modify sources so
  that declarations for fexecve and getline don't clash.
* Tue May 28 2002 sf@suse.de
- %%_lib fixes
* Mon May 27 2002 ro@suse.de
- fixed typo in specfile
* Mon May 27 2002 pthomas@suse.de
- Initial package creation.
